import pandas as pd
import os

def repo_id_from_upstream(vcs_link):
    if 'github' in vcs_link:
        repo_id = vcs_link[len('https://github.com/'):]
    else:
        parts = vcs_link.split('/')
        repo_id = '/'.join(parts[3:])
    und_repo_id = '_'.join(repo_id.split("/"))
    return und_repo_id

def get_readme_list(csv_path):
    #main_df = pd.read_csv('final_data/deb_full_data.csv')
    existing_list = pd.read_csv(csv_path)
    existing_list['repo_id'] = existing_list['upstream_vcs_link'].apply(repo_id_from_upstream)
    present_data = existing_list[['upstream_vcs_link', 'repo_id']]
    present_data.to_csv('012925_readme_manifest.csv', index=False)


def get_contributing_list(csv_path):
    existing_list = pd.read_csv(csv_path)
    existing_list['repo_id'] = existing_list['upstream_vcs_link'].apply(repo_id_from_upstream)
    present_data = existing_list[['upstream_vcs_link', 'repo_id']]
    present_data.to_csv('012925_contributing_manifest.csv', index=False)


def check_collected_files(dirpath):
    if "contributing" in dirpath:
        manifest = pd.read_csv('012925_contributing_manifest.csv')
    else:
        manifest = pd.read_csv('012925_readme_manifest.csv')
    csv_files = [f for f in os.listdir(dirpath) if f.endswith('_commits.csv')]
    file_ids = {f[:-12] for f in csv_files} 
    manifest_ids = set(manifest["repo_id"])
    
    unmatched_repo_ids = file_ids - manifest_ids
    matched_repo_ids = file_ids & manifest_ids

    unmatched_files = [f for f in csv_files if f[:-12] in unmatched_repo_ids]

    return unmatched_files, matched_repo_ids

def cp_existing_docs(matched_repo_ids, is_readme):
    if not is_readme:
        manifest = pd.read_csv('012925_contributing_manifest.csv')
    else:
        manifest = pd.read_csv('012925_readme_manifest.csv')
    # match the ids to the upstream vcs links 
    # match those to the files in "/data/users/mgaughan/time_specific_files/{doctype}3"
    # copy matched files to "/data/users/mgaughan/kkex/012825_cam_revision_main/first_version_documents/{doctype}/"

def list_for_doc_collection(unmatched_files, is_readme):
    full_data = pd.read_csv('for_batching/deb_full_data.csv')
    # for each file in unmatched files 
    #   load csv as pd dataframe
    #   find the date of the first doctype
    #   find the corresponding hash
    #   find the upstream vcs from the full_data list 
    #   add to csv with those values

if __name__ == "__main__":
    #get_contributing_licsv_files = [f for f in os.listdir(dirpath) if f.endswith('_commits.csv')]
    is_readme = True
    unmatched_files, matched_repo_ids = check_collected_files("/data/users/mgaughan/kkex/012825_cam_revision_main/main_commit_data/contributing")
    print(len(unmatched_files))
    print(len(matched_repo_ids))